#include "camera.h"

Camera::Camera() {
	pos = Vector(0, 0, 0);
	rot = Vector(0, 0, 0);

	fieldOfView  = 70.f;
	aspectRatio = 1.f;
	nearPlane = 10.f;
	farPlane = 10000.f;
}

void Camera::use() {
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(fieldOfView, aspectRatio, nearPlane, farPlane);
	glMatrixMode(GL_MODELVIEW);

	glLoadIdentity();
	glRotatef(-rot.z, 0, 0, 1);
	glRotatef(-rot.x, 1, 0, 0);
	glRotatef(-rot.y, 0, 1, 0);
	_glTranslateVec(-pos);
}

// Stole this function from my previous LD48 entry
Vector Camera::getMouseVector(int mx, int my) {
	GLdouble model[16], proj[16];
	GLint viewport[4];

	glGetDoublev(GL_MODELVIEW_MATRIX, model);
	glGetDoublev(GL_PROJECTION_MATRIX, proj);
	glGetIntegerv(GL_VIEWPORT, viewport);

	GLdouble x,y,z, x2, y2, z2;
	gluUnProject(mx, viewport[3] - my, 0.f, model, proj, viewport, &x, &y, &z);
	gluUnProject(mx, viewport[3] - my, 1.f, model, proj, viewport, &x2, &y2, &z2);

	return normal(Vector(float(x2-x),float(y2-y),float(z2-z)));
}

LookAtCamera::LookAtCamera() {
}

void LookAtCamera::use() {
	Camera::use();

	glLoadIdentity();
	gluLookAt(pos.x, pos.y, pos.z, target.x, target.y, target.z, 0, 1, 0);
}

