#ifndef GAME_H
#define GAME_H

#include "common.h"
#include "math3d.h"

class Camera;
class Resources;
class Mesh;
class Timer;
class Font;
class World;
class Object;
class Player;
class LookAtCamera;

class Game {
	bool init();
	bool loop();

	void startStandardLighting();
	void stopStandardLighting();

public:
	// game modes
	enum {GM_NORMAL, GM_DYING, GM_GAMEOVER, GM_MENU, GM_EDITOR, GM_PAUSE, GM_INIT};

	Resources *resources;
	Timer *timer;

	int width, height;
	bool done, fullscreen, compatibilityMode;

	Vector bgColor;

	int mode;

	Object *scene;

	LookAtCamera *defaultCamera;
	Vector curTarget, cameraSpeed, cameraOffset;
	int cameraMode, cameraModeNb;

	Camera *editorCamera;

	Vector editorCamSpeed;

	World *world;
	Player *player;

	Vector startPosition, lastSavePoint;
	int lastLevelReached;

	//editor mode
	int editLevel, curTile, curItem;
	bool hideInactive;
	bool editItems;

	bool help;

	// test stuff
	Mesh *testMesh;

	char *display;

	void restartGame(bool levelOne, bool editorMode);

public:
	Game();
	virtual ~Game();

	int start();
};

#endif